function y = polyvalm(P0,M)
%POLYVALM Evaluate a polynomial with a matrix argument
%
% Y = POLYVALM(P0,M) return the value of a polynomial P0 in a matrix M.
%
% See also: POL/POLYVAL.

% Author(s):    Z. Hurak   02-15-2001
% Copyright (c) 2001 by PolyX, Ltd.
% $Revision: 1.0.0 $  $Date: 02-15-2001 $

%-----------------------------------------------------------------------------

global PGLOBAL;
eval('PGLOBAL.FORMAT;',...
   'error(''Use PINIT to initialize the Polynomial Toolbox.'');');

%=============================================================================
% Tests for proper inputs: 
%=============================================================================

if nargin ~= 2
    error('Two input arguments required.');
end

if ~isa(P0,'pol') | ~isnumeric(M)
    error('Incompatible input arguments.');
end

[rowM, colM] = size(M);
if rowM ~=colM
    error('Square matrix required.');
end

%=============================================================================
% Body: 
%=============================================================================

y = zeros(rowM);

P0c = P0.c;
for ii=(deg(P0)+1):-1:1
    y = M * y + P0c(:,:,ii) * eye(rowM);
end

% end of .../polyvalm.m
